<?php
/**
 * Welcome
 */
class blos_screen {

	public function __construct() {

		add_action( 'admin_menu', array( $this, 'blos_register_menu' ) );
		add_action( 'load-themes.php', array( $this, 'blos_activation_admin_notice' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'blos_style_and_scripts' ) );
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'blos_scripts_for_customizer' ) );
        
		/* Welcome Screen Builder */
		
		add_action( 'blos_info_screen', array( $this, 'blos_getting_started' ), 	    10 );
		add_action( 'blos_info_screen', array( $this, 'blos_action_required' ), 	    30 );
		add_action( 'blos_info_screen', array( $this, 'blos_github' ), 		            20 );
		add_action( 'wp_ajax_blos_dismiss_required_action', array( $this, 'blos_dismiss_required_action_callback') );
		add_action( 'wp_ajax_nopriv_blos_dismiss_required_action', array($this, 'blos_dismiss_required_action_callback') );

	}

	public function blos_register_menu() {
		add_theme_page( 'Theme About', 'Theme About', 'activate_plugins', 'blos-info', array( $this, 'blos_welcome_screen' ) );
	}

	public function blos_activation_admin_notice() {
		global $pagenow;

		if ( is_admin() && ('themes.php' == $pagenow) && isset( $_GET['activated'] ) ) {
			add_action( 'admin_notices', array( $this, 'blos_admin_notice' ), 99 );
		}
	}

	/**
	 * @sfunctionse 1.8.2.4
	 */
	public function blos_admin_notice() {
		?>
			<div class="updated notice is-dismissible">
				<p><?php echo sprintf( esc_html__( 'Welcome! Thank you for choosing the blos multipurpose wp theme! Start by examining usage to fully utilize the best advantage your theme offers', 'blos' ), '<a href="' . esc_url( admin_url( 'themes.php?page=blos-info' ) ) . '">', '</a>' ); ?></p>
				<p><a href="<?php echo esc_url( admin_url( 'themes.php?page=blos-info' ) ); ?>" class="button" style="text-decoration: none;"><?php _e( 'Start using the blos theme', 'blos' ); ?></a></p>
			</div>
		<?php
	}

	/**
	 * @sfunctionse  1.8.2.4
	 */
	public function blos_style_and_scripts( $hook_suffix ) {

		if ( 'appearance_page_blos-info' == $hook_suffix ) {
			
			wp_enqueue_style( 'blos-info-css', get_template_directory_uri() . '/inc/welcome/css/bootstrap.css' );
			wp_enqueue_style( 'blos-info-screen-css', get_template_directory_uri() . '/inc/welcome/css/welcome.css' );
			wp_enqueue_script( 'blos-info-screen-js', get_template_directory_uri() . '/inc/welcome/js/welcome.js', array('jquery') );

			global $blos_required_actions;

			$nr_actions_required = 0;

			if( get_option('blos_show_required_actions') ):
				$blos_show_required_actions = get_option('blos_show_required_actions');
			else:
				$blos_show_required_actions = array();
			endif;

			if( !empty($blos_required_actions) ):
				foreach( $blos_required_actions as $blos_required_action_value ):
					if(( !isset( $blos_required_action_value['check'] ) || ( isset( $blos_required_action_value['check'] ) && ( $blos_required_action_value['check'] == false ) ) ) && ((isset($blos_show_required_actions[$blos_required_action_value['id']]) && ($blos_show_required_actions[$blos_required_action_value['id']] == true)) || !isset($blos_show_required_actions[$blos_required_action_value['id']]) )) :
						$nr_actions_required++;
					endif;
				endforeach;
			endif;

			wp_localize_script( 'blos-info-screen-js', 'blosLiteWelcomeScreenObject', array(
				'nr_actions_required' => $nr_actions_required,
				'ajaxurl' => admin_url( 'admin-ajax.php' ),
				'template_directory' => get_template_directory_uri(),
				'no_required_actions_text' => __( 'No action is required for you right now.','blos' )
			) );
		}
	}

	/**
	 * @sfunctionse  1.8.2.4
	 */
	public function blos_scripts_for_customizer() {

		wp_enqueue_style( 'blos-screen-customizer-css', get_template_directory_uri() . '/inc/blos/css/welcome_customizer.css' );
		wp_enqueue_script( 'blos-screen-customizer-js', get_template_directory_uri() . '/inc/blos/js/welcome_customizer.js', array('jquery'), '20120206', true );

		global $blos_required_actions;

		$nr_actions_required = 0;

		if( get_option('blos_show_required_actions') ):
			$blos_show_required_actions = get_option('blos_show_required_actions');
		else:
			$blos_show_required_actions = array();
		endif;

		if( !empty($blos_required_actions) ):
			foreach( $blos_required_actions as $blos_required_action_value ):
				if(( !isset( $blos_required_action_value['check'] ) || ( isset( $blos_required_action_value['check'] ) && ( $blos_required_action_value['check'] == false ) ) ) && ((isset($blos_show_required_actions[$blos_required_action_value['id']]) && ($blos_show_required_actions[$blos_required_action_value['id']] == true)) || !isset($blos_show_required_actions[$blos_required_action_value['id']]) )) :
					$nr_actions_required++;
				endif;
			endforeach;
		endif;

		wp_localize_script( 'blos-info-screen-customizer-js', 'blosLiteWelcomeScreenObject', array(
			'nr_actions_required' => $nr_actions_required,
			'aboutpage' => esc_url( admin_url( 'themes.php?page=blos-info#actions_required' ) ),
			'customizerpage' => esc_url( admin_url( 'customize.php#actions_required' ) ),
			'themeinfo' => __('View Theme Info','blos'),
		) );
	}

	/**
	 * @sfunctionse 1.8.2.4
	 */
	public function blos_dismiss_required_action_callback() {

		global $blos_required_actions;
		$blos_dismiss_id = (isset($_GET['dismiss_id'])) ? $_GET['dismiss_id'] : 0;
		echo $blos_dismiss_id; 
		if( !empty($blos_dismiss_id) ):

			if( get_option('blos_show_required_actions') ):
				$blos_show_required_actions = get_option('blos_show_required_actions');
				$blos_show_required_actions[$blos_dismiss_id] = false;
				update_option( 'blos_show_required_actions',$blos_show_required_actions );


			else:

				$blos_show_required_actions_new = array();
				if( !empty($blos_required_actions) ):
					foreach( $blos_required_actions as $blos_required_action ):
						if( $blos_required_action['id'] == $blos_dismiss_id ):
							$blos_show_required_actions_new[$blos_required_action['id']] = false;
						else:
							$blos_show_required_actions_new[$blos_required_action['id']] = true;
						endif;
					endforeach;
				update_option( 'blos_show_required_actions', $blos_show_required_actions_new );
				endif;
			endif;
		endif;
		die(); 
	}

	/**
	 * @sfunctionse 1.8.2.4
	 */
	public function blos_welcome_screen() {

		get_template_part( ABSPATH . 'wp-load.php' );
		get_template_part( ABSPATH . 'wp-admin/admin.php' );
		get_template_part( ABSPATH . 'wp-admin/admin-header.php' );
		
		
		?>
		<div class="container-fluid">
		<div class="row">
		<div class="col-md-12">
		<ul class="blos-nav-tabs" role="tablist">
			<li role="presentation" class="active"><a href="#getting_started" aria-controls="getting_started" role="tab" data-toggle="tab"><?php esc_html_e( 'Beginning','blos'); ?></a></li>
			<li role="presentation"><a href="#github" aria-controls="github" role="tab" data-toggle="tab"><?php esc_html_e( 'Descriptions','blos'); ?></a></li>
			<li role="presentation"><a href="#actions_required" aria-controls="actions_required" role="tab" data-toggle="tab"><?php esc_html_e( 'Other Products','blos'); ?></a></li>

		</ul>
		</div>
		</div>
		</div>

		<div class="blos-tab-content">
			<?php do_action( 'blos_info_screen' ); ?>
		</div>
		<?php
	}

	/**
	 *Started
	 *
	 */
	public function blos_getting_started() {
		require_once ( get_template_directory() . '/inc/welcome/sections/getting-started.php' );
	}
	
	/**
	 * ACtion Required
	 *
	 */
	public function blos_action_required() {
		require_once( get_template_directory() . '/inc/welcome/sections/actions-required.php' );
	}
	
	/**
	 * Github
	 *
	 */
	public function blos_github() {
		require_once( get_template_directory() . '/inc/welcome/sections/github.php' );
	}

}
$GLOBALS['blos_screen'] = new blos_screen();